/**************************************************************************************\
 *                                                                                    *
 * Eagle LegaliZer: Makes any "pirate-marked" Eagle File become an "Original" one. ;D *
 * By ViKT0RY - 2005                                                                  *
 * http://www.vikt0ry.com                                                             *
 *                                                                                    *
\**************************************************************************************/ 

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>

#pragma comment(linker,"/FILEALIGN:0x200 /MERGE:.data=.text /MERGE:.rdata=.text /SECTION:.text,EWR /IGNORE:4078")

unsigned long matriz[] = {
0x046667FB, 0x04676492, 0x046E691E, 0x046E6968,
0x046F69B7, 0x046F698C, 0x046F69EE, 0x046C6E21,
0x046C6E28, 0x046C6E3C, 0x045E6D7C, 0x04437212,
0x044172BE, 0x04467285, 0x04636351, 0x046363E0,
0x046166A2, 0x0461674D, 0x0464655D, 0x046F6989,
0x04536EE5, 0x045A6C7A, 0x045D6DFE, 0x05737297,
0x04556C22, 0x04506EF4, 0x057E7008, 0x0565761E,
0x046363E3, 0x057973DB, 0x057F701D, 0x057C7072,
0x04606600, 0x04636067, 0x046465E1, 0x045C6DBA,
0x055077D8, 0x06697CE8, 0x065743F7, 0x076B4B45,
0x04676560, 0x056A7674, 0x066D7DDF, 0x07584E04,
0x07434FF4, 0x0065539F, 0x006553EF, 0x006B53D1,
0x005D5641, 0x046B6BDF, 0x00405736, 0x04666415,
0x01645A98, 0x017E5565, 0x04606177, 0x01785528,
0x027F5D23, 0x9B8D9DDB, 0x026823C2, 0x03702528,
0x03632BFE, 0x035B2C09, 0x035F2D25, 0x0C75303B,
0x0C6136CF, 0x00000000
};

int argc=0;
char *argv[256];
char *cmdline=0;
unsigned long startvalue=0;

char *outbuffer=0;
char *outaux=0;

unsigned long random_number(unsigned long min, unsigned long max) {
	srand((unsigned int)time(NULL));
	return (min + rand() % (max - min));
}

char make_checksum(byte *p) {
	int i=0, j=0;
	unsigned long checksum=0;
	char byte=0, value=0, xorvalue=0;
	
	xorvalue=*(char *)(p + 4);

	p+=0x18;

	for(i=0;i<2;i++) {
		checksum=(int)*(p + i * 0x18 + j);
		j+=2;
		while(j<0x18) {
			checksum=checksum << 1;
			if((checksum & 0x80000000)!=0) {
				checksum=checksum ^ 0x80000001;
			}
			checksum+=(char)*(p + (i * 24) + j);
			j++;
		}
		j=0;
		byte=((checksum & 0xFF000000) >> 24) ^ ((checksum & 0xFF0000) >> 16) ^ ((checksum & 0xFF00) >> 8) ^ (checksum & 0xFF);
		value+=byte;
	}
	value=value ^ xorvalue;
	return value;
}

int checkdate(unsigned long value) {
	int magic=0;
	int years=104;

	magic=(value >> 0x10) & 0xFF;
	if(magic > 0x35) {
		return 0;
	} else {
		magic=(value >> 0x18) & 0xFF;
		if(magic < 0x5F) {
			return 0;
		} else {
			years+=0xA;
			if(magic > years) {
				return 0;
			} else {
				if((value & 0xFFFF)==0) {
					return 0;
				} else {
					magic-=0x5E;
					magic*=0xBB8;
					/* magic should be 0x2EE0 */
					if(*(unsigned int short *)(&value) >= magic) {
						return 0;
					} else {
						return 1;
					}
				}
			}
		}
	}

}

int make_second_xor(unsigned long value) {
	int i=0;

	value=matriz[i] ^ 0x64726224;
	while(matriz[i]!=0) {
		if(value==matriz[i]) {
			return (i + 0x12D);
		} else {
			i++;
		}
	}

	return 0;

}

void crypt(unsigned long *first, unsigned long second) {
	*first=((((((~*first) >> 8) ^ second) >> 8) ^ second) >> 8) ^ second;
}

void make_first_xor(char *p) {
	int j=0;
	char xorvalue=0xFC;

	for(j=0;j<9;j++) {
		*(p + j)=*(p + j) ^ xorvalue;
		xorvalue+=0x42;
	}

}

void get_magic(unsigned long *magic, char *magic_checksum) {
	unsigned long last_value1=0;
	unsigned long last_value2=0;
	unsigned long ret=0;
	int j=0;
	char *p=0;
	unsigned char a=0, b=0;
	unsigned int short value1=0, value2=0;
	char xorvalue=0;

	//*magic=random_number(0x9d800000, 0xB5000000);
	*magic=startvalue;

	while(ret==0) {
		
		*magic+=1;

		if(*magic < 0x9d800000) {
			*magic=0x9d800000;
		}

		/*
		if(*magic % 0x01000000 == 0) {
			printf("Calculating... Current value: 0x%X\n", *magic);
		}
		*/

		last_value1=*magic;

		xorvalue=0xFC;
		p=(char *)&last_value1;
		for(j=0;j<4;j++) {
			*(p + j)=*(p + j) ^ xorvalue;
			xorvalue+=0x42;
		}

		p=&last_value1;
		a=*(unsigned char *)(p + 3);
		b=*(unsigned char *)(p + 2);
		if((a < 0x5F) || (b > 0x34) || (a > 0x72)) {
			ret=0;
			continue;
		}

		value1=*(unsigned int short *)(&last_value1);
		value2=(unsigned int short)0xBB0 * (a - 0x5E);
		if(value1 > value2) {
			ret=0;
			continue;
		}

		last_value2=last_value1;
		crypt(&last_value2,last_value2);
		*magic_checksum=(last_value2 & 0xFF) ^ xorvalue;
		
		ret=make_second_xor(*magic);

		if(ret!=0) {
			ret=0;
			continue;
		}

		ret=*magic ^ 0x68637324;

		if((ret==0x0A7A6DA0) || (ret==0x096962F4) || (ret==0x0E533B97) || (ret==0x044F621B) || (ret==0x9447572) || (ret==0x376279D8)) {
			ret=0;
			continue;
		}

		ret++;
	}

}

int fixfile(char *filename){

	/* This function fixes the file so that Legal Eagle can open it :D */

	HANDLE hFile=0;
	HANDLE hMapped=0;
	BYTE *lpBaseAddress=0;

	unsigned long magic[2]={ 0, 0 };
	unsigned long offset=2;
	unsigned long temp=0;
	char magic_checksum[2]={ 0, 0 };
	char checksum=0;
	char flag=0;
	int i=0,j=0;
	int short number_of_checkpoints=0;

	hFile=CreateFile(filename, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if(hFile==INVALID_HANDLE_VALUE) {
		wsprintf(outaux,"Couldn't open '%s' for writing!\n", filename);
		lstrcat(outbuffer,outaux);
		return -1;
	}

	hMapped = CreateFileMapping(hFile, NULL, PAGE_READWRITE, 0, 0, NULL);
	if(hMapped == NULL) {
		CloseHandle(hFile);
		lstrcat(outbuffer,"Error creating file mapping :(\n");
		return -1;
	} else {
		lpBaseAddress = (BYTE *) MapViewOfFile(hMapped, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	}

	/*********************************************************************************/

	get_magic(&magic[0], &magic_checksum[0]);
	get_magic(&magic[1], &magic_checksum[1]);

	number_of_checkpoints=*(int short *)(lpBaseAddress + offset);
	offset+=22;
	
	for(i=number_of_checkpoints;i>=0;i--) {
		flag=*(char *)(lpBaseAddress + offset);
		if(flag == 0x11) {
			offset+=2;
			for(j=0;j<2;j++) {
				*(unsigned long *)(lpBaseAddress + offset) = (unsigned long)magic[j];
				offset+=4;
				temp=magic_checksum[j] & 0xFF;
				temp=(temp & 0xFFF0FFFF) | 0x90000;
				*(unsigned long *)(lpBaseAddress + offset) = (unsigned long) temp;
				offset+=4;
				*(int short *)(lpBaseAddress + offset) = (int short) 0;
				offset+=2;
				*(char *)(lpBaseAddress + offset) = (char) 0;
				offset++;
			}
		}
	}

	checksum=make_checksum((char *)lpBaseAddress);

	offset=0x0D;

	*(lpBaseAddress + offset)=checksum;

	*(lpBaseAddress + offset - 1)=0;

	/*********************************************************************************/

	if(hFile) {
		FlushFileBuffers(hFile);
		CloseHandle(hFile);
		hFile=NULL;
	}
	if (lpBaseAddress) {
		UnmapViewOfFile(lpBaseAddress);
		lpBaseAddress=NULL;
	}
	if (hMapped) {
		CloseHandle(hMapped);
		hMapped=NULL;
	}

	return 1;

}

int checkfile(char *filename){

	/* This function makes the same comprobations as original Eagle source :D */

	HANDLE hFile=0;
	HANDLE hMapped=0;
	BYTE *lpBaseAddress=0;

	unsigned long offset=0;
	int i=0;

	char flag=0;
	int check=1;
	int counter=0;
	int version=0;
	int result=0;
	char checksum=0;
	unsigned long temp=0;
	unsigned char checksum2=0;
	int short number_of_checkpoints=0;

	unsigned long last_value=0;
	char buffer[11];
	unsigned long *first_dword=(unsigned long *)buffer;
	unsigned long *second_dword=(unsigned long *)(buffer + 4);
	int short *word=(int *)(buffer + 8);
	char *byte=(int *)(buffer + 10);
	char ret1=0, ret2=0, tempxor=0;
	

	hFile=CreateFile(filename, GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if(hFile==INVALID_HANDLE_VALUE) {
		wsprintf(outaux,"Couldn't open '%s' for writing!\n", filename);
		lstrcat(outbuffer,outaux);
		return -1;
	}

	hMapped = CreateFileMapping(hFile, NULL, PAGE_READWRITE, 0, 0, NULL);
	if(hMapped == NULL) {
		CloseHandle(hFile);
		lstrcat(outbuffer,"Error creating file mapping :(\n");
		return -1;
	} else {
		lpBaseAddress = (BYTE *) MapViewOfFile(hMapped, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	}

	/*********************************************************************************/

	flag=*(char *)lpBaseAddress;

	if(flag != 0x10) {
		strcat(outbuffer,"File seems to have an improper format!\n");
		return 2;
	}

	offset+=2;

	number_of_checkpoints=*(int short *)(lpBaseAddress + offset);

	offset+=6;

	version=(*(int *)(lpBaseAddress + offset)) & 0xFFFF;
	version=(version >> 8) + ((version & 0xFF) << 8);

	offset+=4;

	checksum2=*(char *)(lpBaseAddress + offset);

	offset++;
	checksum=*(char *)(lpBaseAddress + offset);

	offset+=11;

	for(i=number_of_checkpoints;i>=0;i--) {
		flag=*(char *)(lpBaseAddress + offset);
		if(flag == 0x11) {
			offset+=2;
			counter=0;
			while(counter<2) {
				*first_dword=*(unsigned long *)(lpBaseAddress + offset);
				offset+=4;
				startvalue=*first_dword;
				*second_dword=*(unsigned long *)(lpBaseAddress + offset);
				offset+=4;
				*word=*(int short *)(lpBaseAddress + offset);
				offset+=2;
				*byte=*(char *)(lpBaseAddress + offset);
				offset++;

				make_first_xor(buffer);

				last_value=*first_dword;

				if(*first_dword != 0) {
					crypt(&last_value, *first_dword);
					ret1=last_value & 0xFF;
					crypt(&last_value, *first_dword);
					ret2=last_value & 0xFF;
					tempxor=(*second_dword & 0xFF);
					if(ret1 != tempxor) {
						return 0;
					}
					if(make_second_xor(*first_dword)!=0) {
						return 0;
					}
					if((*first_dword ^ 0x68637324) != 0x0A7A6DA0) {
						if(((*second_dword & 0xF0000) >> 16)==1) {
							if(checkdate(*first_dword)==0) {
								return 0;
							} else {
								if(check!=0) {
									if(version >= 0x40A) {
										temp=(*first_dword ^ 0x68637324);
										if(temp != 0x096962F4) {
											if(temp != 0x0E533B97) {
												if(temp != 0x044F621B) {
													if(temp != 0x9447572) {
														if(temp != 0x376279D8) {
															check=0;
														} else {
															result=0;
															goto end;
														}
													} else {
														result=0;
														goto end;
													}
												} else {
													result=0;
													goto end;
												}
											} else {
												result=0;
												goto end;
											}
										} else {
											result=0;
											goto end;
										}
									} else {
										temp=(*first_dword ^ 0x68637324);
										if(temp != 0x0E533B97) {
												if(temp != 0x044F621B) {
													if(temp != 0x9447572) {
														if(temp != 0x376279D8) {
															check=0;
														} else {
															result=0;
															goto end;
														}
													} else {
														result=0;
														goto end;
													}
												} else {
													result=0;
													goto end;
												}
											} else {
												result=0;
												goto end;
											}
									}
								} else {
									temp=(*first_dword ^ 0x68637324);
									if(temp != 0x0E533B97) {
											if(temp != 0x044F621B) {
												if(temp != 0x9447572) {
													if(temp != 0x376279D8) {
														check=0;
													} else {
														result=0;
														goto end;
													}
												} else {
													result=0;
													goto end;
												}
											} else {
												result=0;
												goto end;
											}
										} else {
											result=0;
											goto end;
									}
								}
							}
						} else {
							result=0;
							goto end;
						}
					} else {
						result=0;
						goto end;
					}

				}

				counter++;

			}

		}
	}

	if(offset==0x18 || check==1) {
		return 0;
	}

	if(make_checksum((char *)lpBaseAddress) != checksum) {
		return 0;
	}

	if((checksum2 == 0x80) || (checksum2==0x40)) {
		return 0;
	}

	result=1;

	/*********************************************************************************/

end:

	if(hFile) {
		FlushFileBuffers(hFile);
		CloseHandle(hFile);
		hFile=NULL;
	}
	if (lpBaseAddress) {
		UnmapViewOfFile(lpBaseAddress);
		lpBaseAddress=NULL;
	}
	if (hMapped) {
		CloseHandle(hMapped);
		hMapped=NULL;
	}

	return result;

}

void ParseCmdLine(char *cmd, int *count, char *list[256]){
	int i=0;
	char *p=cmd;
	int parametro=0;

	while((i<256) && (strlen(p)>0)) {
		if(*p!=' '){
			if(*p=='"') {
				if(parametro==0){
					parametro=1;
					argv[i]=p + 1;
					i++;
				} else {
					parametro=0;
					*p=0;
				}
			} else {
				if(parametro==0){
					parametro=2;
					argv[i]=p;
					i++;
				}
			}
		} else {
			if(parametro==2){
				parametro=0;
				*p=0;
			}
		}
		p++;
	}
	*count=i;
}

int AddContextMenu(char *extension,char *data){
	char temp[512]="";
	DWORD dwsize=0;
	HKEY hkey;
	HKEY hkey2;

	if(RegOpenKey(HKEY_CLASSES_ROOT,extension,&hkey)==ERROR_SUCCESS) {
		dwsize=512;
		RegQueryValueEx(hkey, 0, 0, 0, temp, &dwsize);
		if(lstrlen(temp)==0 || lstrcmpi(temp,"Eagle_LegaliZer")==0) {
			lstrcpy(temp,"Eagle_LegaliZer");
			dwsize=lstrlen(temp);
			RegSetValueEx(hkey, 0, 0, REG_SZ, temp, dwsize);
			RegCloseKey(hkey);
			if(RegCreateKey(HKEY_CLASSES_ROOT,temp,&hkey)!=ERROR_SUCCESS) {
				RegOpenKey(HKEY_CLASSES_ROOT,temp,&hkey);
			}
		} else {
			RegCloseKey(hkey);
			RegOpenKey(HKEY_CLASSES_ROOT,temp,&hkey);
		}
		lstrcpy(temp,"shell\\Fix with Eagle LegaliZer");
		if(RegCreateKey(hkey,temp,&hkey2)==ERROR_SUCCESS) {
			RegCloseKey(hkey);
			lstrcpy(temp, "command");
			if(RegCreateKey(hkey2,temp,&hkey)==ERROR_SUCCESS) {
				dwsize=lstrlen(data);
				RegSetValueEx(hkey, 0, 0, REG_SZ, data, dwsize);
				RegCloseKey(hkey);
				RegCloseKey(hkey2);
				return 1;
			} else {
				return 0;
			}
		} else {
			return 0;
		}
	} else {
		return 0;
	}
}

int RemoveContextMenu(char *extension){
	char temp[512]="";
	DWORD dwsize=0;
	HKEY hkey;

	if(RegOpenKey(HKEY_CLASSES_ROOT,extension,&hkey)==ERROR_SUCCESS) {
		dwsize=512;
		RegQueryValueEx(hkey, 0, 0, 0, temp, &dwsize);
		RegCloseKey(hkey);
		if(RegOpenKeyEx(HKEY_CLASSES_ROOT,temp,0,KEY_ALL_ACCESS,&hkey)==ERROR_SUCCESS) {
			lstrcpy(temp,"shell\\Fix with Eagle LegaliZer\\command");
			RegDeleteKey(hkey,temp);
			lstrcpy(temp,"shell\\Fix with Eagle LegaliZer");
			RegDeleteKey(hkey,temp);
			RegCloseKey(hkey);
		} else {
			return 0;
		}
	} else {
		return 0;
	}
}

void MakeInstall(void){
	char path[256]="";

	GetWindowsDirectory(path,255);

	lstrcat(path,"\\Eagle_LegaliZer.exe \"%1\"");

	AddContextMenu(".brd",path);
	AddContextMenu(".sch",path);
	AddContextMenu(".lbr",path);
	
}


void RemoveInstall(void){
	
	RemoveContextMenu(".brd");
	RemoveContextMenu(".sch");
	RemoveContextMenu(".lbr");
	
}

int WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance, LPSTR lpCmdLine,int nCmdShow)
{

	int ret=0;
	int force=0;
	int i=0;

	cmdline=(char *)malloc(lstrlen(GetCommandLine()) + 1);

	lstrcpy(cmdline, GetCommandLine());

	ParseCmdLine(cmdline, &argc,argv);

	if(argc==2){
		if(!lstrcmpi(argv[1], "-i")){
			MakeInstall();
			return 0;
		} else if(!lstrcmpi(argv[1], "-d")) {
			RemoveInstall();
			return 0;
		}
	}

	outbuffer=(char *)malloc(20000);
	outaux=(char *)malloc(1000);

	lstrcpy(outbuffer,"\n");
	lstrcat(outbuffer,"\t\t\t\t  \n");
	lstrcat(outbuffer," Eagle LegaliZer v1.2 by ViKT0RY\t  \n");
	lstrcat(outbuffer,"\t\t\t\t  \n");
	lstrcat(outbuffer," http://www.vikt0ry.com\t\t  \n");
	lstrcat(outbuffer,"\t\t\t\t  \n");
	lstrcat(outbuffer,"\n\n");

	if(argc>1){
		if(!lstrcmpi(argv[1], "-f")){
			force=1;
		}
	}

	if((force && argc < 3) || (!force && argc < 2)) {
		lstrcat(outbuffer,"You must specify a file to patch!\n\nUsage: Eagle_LegaliZer.exe [-f] File.[sch]|[brd]|[lbr] ...\n");
		lstrcat(outbuffer,"\nThis means that you can legalize any schema, board or library, use the parameter -f to force repair.");
		MessageBox(0,outbuffer,"Notice",MB_ICONEXCLAMATION);
		return 0;
	}
	
	for(i=1;i<argc;i++){

		if(force && i==1) {
			i++;
		}

		ret=checkfile(argv[i]);
	
		if(ret==1) {
			if(!force) {
				wsprintf(outaux,"The file '%s' seems to be legal...\n", argv[i]);
				lstrcat(outbuffer,outaux);
				continue;
			}
		} else if(ret==2 || ret==-1) {
			continue;
		}
	
		ret=fixfile(argv[i]);
		if(ret==0) {
			wsprintf(outaux,"Couldn't fix the file '%s'! :(\n",argv[i]);
		} else {
			wsprintf(outaux,"File '%s' fixed successfully! :D\n", argv[i]);
		}
		
		lstrcat(outbuffer,outaux);

	}

	MessageBox(0,outbuffer,"Notice",MB_ICONINFORMATION);

	free(outbuffer);
	free(outaux);
	free(cmdline);

	return 0;

}

